/*
 *  IBM timer device driver
 *
 *  (c) 1998, Yoav Shadmi
 *
 */

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"

#include "prefs.h"
#include "screen.h"

#include "IBM-TIME.h"
#include "IBM-VGA.h"
#include "IBM-UI.h"

#include <go32.h>
#include <dpmi.h>
#include <stdio.h>
#include <conio.h>
#include <signal.h>

#include "allegro.h"

// Timer device driver
volatile int IntVBL=0;
volatile int IntSEC=0;

static void Timer_HandlerVBL (void)
{
   IntVBL=1;

   return;
}

static void Timer_HandlerSEC (void)
{
   IntSEC=1;

   return;
}

int Timer_Install(void)
{
   int result;

   install_timer();

   result = install_int_ex(Timer_HandlerVBL, BPS_TO_TIMER(60));
   if (result != 0) {
      VGA_EnterDebug();
      _set_screen_lines(25);
      _quit_=1;
      fprintf(stderr, "vMac: Can't install VBL handler.\n");
      DumpMessages();
      raise(SIGUSR1);
      return 0;
   }

   result = install_int_ex(Timer_HandlerSEC, BPS_TO_TIMER(1));
   if (result != 0) {
      VGA_EnterDebug();
      _set_screen_lines(25);
      _quit_=1;
      fprintf(stderr, "vMac: Can't install 1-Second handler.\n");
      DumpMessages();
      raise(SIGUSR1);
      return 0;
   }

   return 1;
}

void Timer_Uninstall(void)
{
   remove_timer();

   return;
}

void Timer_LockDriver (void)
{
   _go32_dpmi_lock_code (Timer_HandlerVBL, (unsigned int)Timer_HandlerSEC - (unsigned int)Timer_HandlerVBL);
   _go32_dpmi_lock_code (Timer_HandlerSEC, (unsigned int)Timer_Install    - (unsigned int)Timer_HandlerSEC);

   _go32_dpmi_lock_data (&IntVBL, (unsigned int)sizeof(IntVBL));
   _go32_dpmi_lock_data (&IntSEC, (unsigned int)sizeof(IntSEC));

   return;
}
