// vMac 0.1 Source
// By Philip Cummins (PC)
// Copyright PC 1997
   
// PC - Mac Screen Headers

#define RegScreen         0xa0000

#define kVRAM_Base        0x5a0000
#define kVRAM_Top         0x600000
#define kVRAM_Size        kVRAM_Top - kVRAM_Base

#define kMain_Offset      0x000000
#define kAlternate_Offset 0x300000

#define kMain_Buffer      (kVRAM_Base + kMain_Offset)
#define kAlternate_Buffer (kVRAM_Base + kAlternate_Offset)

#define kOld_Main_Offset      0x5900
#define kOld_Alternate_Offset 0xD900
#define kOld_Main_Buffer      (kRAM_Size - kOld_Main_Offset)
#define kOld_Alternate_Buffer (kRAM_Size - kOld_Alternate_Offset)

#define scrnBase     kVRAM_Base
#define Top          0
#define Left         0

// 512x342
#define Bottom1      342
#define Right1       512
#define rowBytes1    Right2/8
#define screenBytes1 Bottom1*rowBytes2

// 640x480
#define Bottom2      480
#define Right2       640
#define rowBytes2    Right2/8
#define screenBytes2 Bottom1*rowBytes2


int  Screen_Init       (int argc, char **argv);
void Screen_Reset      (void);
void DumpMessages      (void);
void Quit_Emulator     (void);
void Reset_Emulator    (void);


// VIA Interface Headers
UBYTE VIA_GORA6 (void); // Main/Alternate Screen Buffer
void  VIA_PORA6 (UBYTE Data);

UBYTE VIA_GORB6 (void); // Video Beam in Display
void  VIA_PORB6 (UBYTE Data);
